VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cCategory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

'Private storage for data within each object of the class
Private mstrName         As String
Private mlngColor        As Long
Private mlngRow          As Long

'Public collection for Outlook Appointment Items
Public Appointments  As Collection


Private Sub Class_Initialize()
    'This procedure is called when a new object of this class is created
    
    With gfrmPlanner.flxCategories
        'We add an extra row to the FlexGrid
        .Rows = .Rows + 1
        
        'We remember which row we are in
        '(a zero based array so subtract one from the total number of rows)
        mlngRow = .Rows - 1
    End With
    
    'We create the new collection to store Appointment Items
    Set Appointments = New Collection
End Sub


Private Sub Class_Terminate()
    'This procedure is called when an object of this class is destroyed
    'We want to ignore any errors
    On Error Resume Next
    
    'Remove our row from the FlexGrid
    gfrmPlanner.flxCategories.RemoveItem mlngRow
    
    'Destroy our collection of Appointment Items
    Set Appointments = Nothing
End Sub


Public Property Let Name(ByVal istrNewName As String)
    'This procedure is called when a name is assigned to an object of this class
    'We remember the name
    mstrName = istrNewName
    'and we display the name in the FlexGrid
    gfrmPlanner.flxCategories.TextMatrix(mlngRow, 0) = mstrName
End Property


Public Property Get Name() As String
    'This is called when our object is asked for its name
    Name = mstrName
End Property


Public Property Let Color(ByVal ilngNewColor As Long)
    'This is called when our object is assigned a color
    Dim lngOldRow As Long       'We need to remember which row in the grid was highlighted
    
    'Remember our new color
    mlngColor = ilngNewColor
    
    With gfrmPlanner.flxCategories
        .Redraw = False                 'Don't repaint for a moment
        lngOldRow = .Row                'Remember where we were
        .Row = mlngRow                  'Move to the row for this category
        .Col = 1                        'Color patches are in row 1
        .CellBackColor = ilngNewColor   'Assign the new color
        .Col = 0                        'Move back to the text column
        .Row = lngOldRow                'Move back to the row we were on
        .Redraw = True                  'Now we can repaint the grid
    End With
    
End Property


Public Property Get Color() As Long
Attribute Color.VB_UserMemId = 0
    'This is called when our object is asked for its color
    Color = mlngColor
End Property


Public Property Get Row() As Long
    'This is called when our object is asked for its row
    'There is no correspondint Property Let Row() procedure
    'So this property is read only
    'The row is determined in the Class_Initialize event
    Row = mlngRow
End Property


Public Sub EditColor()
    'This is called to display the Color Dialog
    Dim objAppointment As AppointmentItem   'Temp pointer to an Appointment
    
    With gfrmPlanner
        .dlgColor.Color = Color         'Set the dialog to show the current color
        .dlgColor.ShowColor             'Show the dialog - allow the user to pick a color
        Color = .dlgColor.Color         'Set the color to the one picked
                                        'Calls the Property Let Color procedure above
    End With
    
    For Each objAppointment In Appointments
        'Run through all the appointments for this category
        'and mark them with the new color
        gfrmPlanner.MarkDate objAppointment, False
    Next objAppointment
    
End Sub
