VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmDay 
   Caption         =   "Day"
   ClientHeight    =   3420
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "Day.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3420
   ScaleWidth      =   4680
   StartUpPosition =   1  'CenterOwner
   Begin MSFlexGridLib.MSFlexGrid flxDay 
      Height          =   3135
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4215
      _ExtentX        =   7435
      _ExtentY        =   5530
      _Version        =   65541
      Rows            =   0
      Cols            =   4
      FixedRows       =   0
      FixedCols       =   0
      BackColorBkg    =   -2147483633
      AllowBigSelection=   0   'False
      FocusRect       =   0
      ScrollBars      =   2
      BorderStyle     =   0
   End
End
Attribute VB_Name = "frmDay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'This form is used to show all the appointments for a day
'so that the user can choose which one to edit

'This will hold all the appointments for the day
Private mcolAppointments As Collection

Private Sub flxDay_Click()
    'This is called when the user clicks on an appointment
    'We make sure that the appointment subject is highlighted
    
    With flxDay
        .Row = .MouseRow
        .Col = 1
    End With
    
End Sub

Private Sub flxDay_DblClick()
    'Called when the user double clicks on an appointment
    'We allow the user to edit this appointment
    mcolAppointments.Item(flxDay.Row + 1).GetInspector.Display
    
End Sub

Private Sub Form_Load()
    'Called when the form is created
    'Set some defaults for the grid
    
    With flxDay
        .ColWidth(0) = 345  'Width of color patch column
        .ColWidth(1) = 1300 'Width of text column
        .ColWidth(2) = 1000 'Width of start date column
        .ColWidth(3) = 1000 'Width of end date column
    End With
    
End Sub

Private Sub Form_Resize()
    'Called when the form changes size
    
    With Me
        'Make the grid fit the form
        flxDay.Move 0, 0, .ScaleWidth, .ScaleHeight
    End With
    
    With flxDay
        'Make the width of the subject grow or shrink
        .ColWidth(1) = Me.ScaleWidth - .ColWidth(0) - .ColWidth(2) - .ColWidth(3)
    End With
    
End Sub

Public Sub ShowDay(ByRef icolAppointments As Collection, ByVal dteThisDay As Date)
    'Called when we need to show the appointments for a day
    
    Dim objAppointment  As AppointmentItem
    
    'Show the date on the form caption
    Me.Caption = "Appointments - " & dteThisDay
    
    'Remember the appointments we've been passed
    Set mcolAppointments = icolAppointments
    
    For Each objAppointment In icolAppointments
        'Show each appointment in a new row in the grid
        
        With flxDay
            'Add a new row
            .Rows = .Rows + 1
            
            'Move to the new row
            .Row = .Rows - 1
            
            'Show the colour patch for this appointment's category
            .Col = 0
            .CellBackColor = ColorForCategory(objAppointment.Categories)
            
            'Show the subject, start and end dates
            .Col = 1
            .Text = objAppointment.Subject
            
            'Adjust the width of the column
            .ColWidth(1) = Max(.ColWidth(1), Me.TextWidth(.Text))
            
            .Col = 2
            
            If (Int(objAppointment.Start) = dteThisDay) And (objAppointment.Start <> dteThisDay) Then
                .Text = Format$(objAppointment.Start, "Short Time")
            Else
                .Text = objAppointment.Start
            End If
            
            'Adjust the width of the column
            .ColWidth(2) = Max(.ColWidth(2), Me.TextWidth(.Text))
            
            .Col = 3
            
            If (Int(objAppointment.End) = dteThisDay) And (objAppointment.End <> dteThisDay) Then
                .Text = Format$(objAppointment.End, "Short Time")
            Else
                
                If (Int(objAppointment.End) = objAppointment.End) And (objAppointment.End = objAppointment.Start + 1) Then
                    .Text = "All day"
                Else
                    .Text = objAppointment.End
                End If
        
            End If
            
            'Adjust the width of the column
            .ColWidth(3) = Max(.ColWidth(3), Me.TextWidth(.Text))
        End With
        
    Next objAppointment
    
    'Resize the form so all the appointments are visible
    'and there is no unused space
    Me.Height = (flxDay.Rows * flxDay.RowHeight(0)) + (Me.Height - Me.ScaleHeight) + (1 * Screen.TwipsPerPixelX)

    Screen.MousePointer = vbDefault
    
    'Show this form
    Me.Show vbModal, gfrmPlanner
End Sub


Private Function Max(ByVal ilngOne As Long, ByVal ilngTwo As Long)
    
    If ilngOne > ilngTwo Then
        Max = ilngOne
    Else
        Max = ilngTwo
    End If
    
End Function
