Attribute VB_Name = "General"
Option Explicit

'Public variables for our link to Outlook
Public gobjOutlook      As Outlook.Application
Public gobjNameSpace    As Outlook.NameSpace
Public gobjCalendar     As Outlook.MAPIFolder

'Internal public variables
Public gintStartOfWeek  As Integer
Public gcolCategories   As cCategories
Public gfrmPlanner      As frmYearPlanner

'API functions to access the registy
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" _
       (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long

Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Public Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" _
       (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long

'Registry constants
Public Const HKEY_CURRENT_USER = &H80000001
Public Const REG_SZ = 1


Sub Main()
    'This is called when the application starts
    Screen.MousePointer = vbHourglass
    
    'Link to Outlook
    Set gobjOutlook = New Outlook.Application
    Set gobjNameSpace = gobjOutlook.GetNamespace("MAPI")
    
    'Get the default calendar
    Set gobjCalendar = gobjNameSpace.GetDefaultFolder(olFolderCalendar)
    
    'Set the start of the display
    gintStartOfWeek = vbMonday
    
    'Create a new planner form
    Set gfrmPlanner = New frmYearPlanner
    
    'Show the form
    Call gfrmPlanner.Show(vbModeless)
    Call gfrmPlanner.PreparePlanner
    Call gfrmPlanner.ShowYear(Year(Date))

    Screen.MousePointer = vbDefault
End Sub


Public Function ColorForCategory(ByVal istrCategory As String) As Long
    'Called when we need to know the colour for a category
    Dim objCategory As cCategory
    Dim lngColor    As Long
    
    If istrCategory = "" Then
        'There is no category
        'Return a default color
        lngColor = vbInactiveTitleBar
    Else
        'Find the right category object
        Set objCategory = gcolCategories(istrCategory)
        
        If objCategory Is Nothing Then
            'We don't have one for that category
            'See if we used to know a colour for this category
            'If we didn't then use Red as a default
            lngColor = GetSetting(App.Title, "Categories", istrCategory, vbRed)
            
            'Create a new category object and add it to the collection
            Set objCategory = gcolCategories.Add(istrCategory, lngColor)
        Else
            'We have a category object
            'Retrieve its color
            lngColor = objCategory.Color
        End If
            
    End If

    'Return the color to the calling routine
    ColorForCategory = lngColor
End Function
